<template>
  <div>
    <b-table :data="scores"
             :striped="true"
             :loading="loading"
             :hoverable="true">
      <b-table-column :label="$t('levels.name')"
                      sortable
                      :custom-sort="sortLevel"
                      centered
                      header-class="is-capitalized"
                      v-slot="props">
        <trophy :type="props.row.level || 'newbie'"
                size="small" />
      </b-table-column>

      <b-table-column field="game"
                      :label="$t('ranking.game')"
                      centered
                      v-slot="props">
        <router-link :to="{ name: 'Game',
                            params: { id: props.row.id } }"
                      class="has-text-weight-bold has-text-green">
          {{ props.row.name }}
        </router-link>
      </b-table-column>

      <b-table-column field="value"
                      :label="$t('user.tab.statsTable.best')"
                      sortable
                      centered
                      v-slot="props">
        {{ $n(props.row.value) }}
      </b-table-column>

      <b-table-column field="star"
                      centered
                      v-slot="props">
        <star :type="props.row.star" />
      </b-table-column>
    </b-table>
  </div>
</template>

<script lang="ts">
import { Component, Prop, Mixins } from 'vue-property-decorator';
import { Score } from '@/types/scores';
import LoadingMixin from '../../mixins/loading.vue';
import LevelMixin from '@/mixins/level.vue';
import Star from '@/components/Star.vue';
import Trophy from '@/components/Trophy.vue';

@Component({
  components: { Star, Trophy }
})
export default class UserStatsTab extends Mixins(LoadingMixin, LevelMixin) {
  scores: Score[] = [];

  async mounted() {
    const { data } = await this.$http.get(
      `users/highscores/${this.$route.params.id
                          || this.$store.getters.user.id}`
    );

    this.scores = data;
    this.stopLoading();
  }
}
</script>